

CREATE OR REPLACE FUNCTION fCanvasAnalyze(
	_CanvasID	VARCHAR(5),
	_StartDate	DATE,
	_EndDate	DATE
) RETURNS SETOF tCanvas AS 
$BODY$
DECLARE
	_retval		tCanvas%ROWTYPE;
	cCanvasA	refcursor;
	_WhID		VARCHAR(3);

	_QtyStart	NUMERIC(19,4);
	_QtyLoad	NUMERIC(19,4);
	_QtySold	NUMERIC(19,4);
	_QtySellIn	NUMERIC(19,4);
	_QtyMisc	NUMERIC(19,4);
	_QtyUnLoad	NUMERIC(19,4);
	_QtyEnd		NUMERIC(19,4);

BEGIN
	SELECT INTO _WhID WhID FROM Canvas WHERE CanvasID=_CanvasID;
	OPEN cCanvasA FOR
		SELECT
		d.ItemID,
		i.itemdesc,
		fStockBal_StartDate(d.ItemID, _WhID, '', _StartDate) AS Salwal,
		SUM(COALESCE(CASE WHEN h.StockAType='STTR' AND h.InOut='I' THEN fQtyZToQty1(d.ItemID, d.Qty, d.Unit) END, 0)) ,
		SUM(COALESCE(CASE WHEN h.StockAType='SALE' THEN fQtyZToQty1(d.ItemID, d.Qty, d.Unit) END, 0)) ,
		SUM(COALESCE(CASE WHEN h.StockAType='CONS' THEN fQtyZToQty1(d.ItemID, d.Qty, d.Unit) END, 0)) ,
		SUM(COALESCE(CASE WHEN h.StockAType='SRET' THEN fQtyZToQty1(d.ItemID, d.Qty, d.Unit) END, 0)) AS Retur,
		SUM(COALESCE(CASE WHEN h.StockAType='STTR' AND h.InOut='O' THEN fQtyZToQty1(d.ItemID, d.Qty, d.Unit) END, 0)) 
--		fqty1desc(d.ItemID,fStockBal_EndDate(d.ItemID, _WhID,'', _EndDate)) 
		FROM StockAD d 
		JOIN StockA h ON d.StockANo=h.StockANo 
		JOIN item i ON d.itemid=i.itemid
		WHERE d.WhID=_WhID 
		AND h.StockADate>=fNoTime(COALESCE(_StartDate,date('01-01-01'))) 
		AND h.StockADate<=fDate2359(COALESCE(_EndDate,date('9999-12-31')))
		GROUP BY d.ItemID,i.itemdesc;
	LOOP
		FETCH cCanvasA INTO _retval.ItemID, _retval.ItemDesc, _QtyStart, _QtyLoad, _QtySold, _QtySellIn, _QtyMisc, _QtyUnLoad;  
--_QtyEnd;
		EXIT WHEN NOT FOUND;

		_QtyEnd:=COALESCE(_QtyStart,0)+COALESCE(_QtyLoad,0)+COALESCE(_QtySold,0)
				+COALESCE(_QtySellIn,0)+COALESCE(_QtyMisc,0)+COALESCE(_QtyUnLoad,0);

		_retval.QtyStart:=fqty1desc(_retval.ItemID,COALESCE(_QtyStart,0));
		_retval.QtyLoad:=fqty1desc(_retval.ItemID,COALESCE(_QtyLoad,0));
		_retval.QtySold:=fqty1desc(_retval.ItemID,COALESCE(_QtySold,0));
		_retval.QtySellIn:=fqty1desc(_retval.ItemID,COALESCE(_QtySellIn,0));
		_retval.QtyMisc:=fqty1desc(_retval.ItemID,COALESCE(_QtyMisc,0));
		_retval.QtyUnLoad:=fqty1desc(_retval.ItemID,COALESCE(_QtyUnLoad,0));
		_retval.QtyEnd:=fqty1desc(_retval.ItemID,COALESCE(_QtyEnd,0));

		RETURN NEXT _retval;
	END LOOP;
	CLOSE cCanvasA;
END;
$BODY$
LANGUAGE 'plpgsql' VOLATILE;



